#include <stdio.h>
#define MAX(a,b) ((a>b)?a:b)
#define MAX_DEGREE 101

typedef struct{
	int degree;
	float coef[MAX_DEGREE];
} polynomial;

polynomial addPoly(polynomial A, polynomial B)
{
	polynomial C;
	int A_index=0, B_index=0, C_index=0;
	int A_degree=A.degree, B_degree=B.degree;
	C.degree=MAX(A.degree, B.degree);

	while(A_index<=A.degree && B_index<=B.degree){
		if(A_degree > B_degree){
			C.coef[C_index++] = A.coef[A_index++];
			A_degree--;
		}
		else if(A_degree == B_degree){
			C.coef[C_index++] = A.coef[A_index++]+B.coef[B_index++];
			A_degree--; 
			B_degree--;
		}
		else{
			C.coef[C_index++] = B.coef[B_index++];
			B_degree--;
		}	
	}
	return C;
}

void printPoly(polynomial P)
{
	int i, degree;
	degree=P.degree;
	
	for(i=0; i<=P.degree; i++)
		printf("%3.0fx^%d", P.coef[i], degree--);
	printf("\n");
}


int main()
{
polynomial a = { 8, {2, 0, 0, -10, 0, -3, 0, 0, 1} };
polynomial b = { 2, {3, 2, -4} };
polynomial c;

	c= addPoly(a, b);

	printf("\n a(x)=");  printPoly(a);
	printf("\n b(x)=");  printPoly(b);
	printf("\n c(x)=");  printPoly(c);

	getchar();
}
