#include <stdio.h>
#include <stdlib.h>

#define MAX_TERMS 10 

//3ҽ < ε,  ε,  > 
typedef struct {  
  int row;    // ε
  int col;    // ε
  int value;  // 
} element;
 
typedef struct SparseMatrix {
  // Ŀ  
  int rows;   // 
  int cols;   // 
  int terms;  //0 ƴ  
  //0 ƴ ҵ ϴ ü 迭
  element data[MAX_TERMS];  
} SparseMatrix;

//  ϱ
void printSM(SparseMatrix temp){
  printf(" >>     << \n");   
  int r, c, i=0;
  for(r=0; r<temp.rows; r++)  {
    for(c=0; c<temp.cols; c++)
      if(r==temp.data[i].row && c==temp.data[i].col){  
        printf(" %3d", temp.data[i].value);
        i++;    
      }
      else{
        printf(" %3d", 0);       
      }   
    printf("\n"); 
  }
  printf("\n"); 
}

//  ġ  ϱ
SparseMatrix transpose(SparseMatrix a)  
{ 
  SparseMatrix b;

  //b   = a    
  b.rows = a.cols;
  //b   = a    
  b.cols = a.rows;
  
  //b 0 ƴ   
  //b 0 ƴ   
  b.terms = a.terms;
  
  if (a.terms > 0) {  // 0 ƴ  
    int CurrentB = 0;
    for (int c =0; c < a.cols; c++) //  ġ
      for (int i = 0; i < a.terms; i++)
        //  cκ Ҹ ã ̵Ų.
        if (a.data[i].col == c) {
          b.data[CurrentB].row = a.data[i].col;
          b.data[CurrentB].col = a.data[i].row;
          b.data[CurrentB].value = a.data[i].value;
          CurrentB++;
        }
  }// if (terms >0) 
  return b;
}

void storeSum(int* sum, const int row, const int column,
              SparseMatrix* d, int* totalD)
{      
  /*  *sum != 0̸,     ġ Բ
       d *totalD+1 ҷ Ѵ. */         
  if(*sum){
      d->data[++*totalD].row = row;
      d->data[*totalD].col = column;  
      d->data[*totalD].value = *sum;  
      *sum=0;   
  }                 
}

//   ϱ
SparseMatrix multiply(SparseMatrix a, SparseMatrix b)  
{ 
  //   ϱ ؼ A  ũⰡ 
  //B  ũⰡ ƾ Ѵ. 
  if(a.cols != b.rows ){
    fprintf(stderr," ũ \n");
    exit(1);
  }    
  //b ġ   
  SparseMatrix bXpose = transpose(b);  

  //a b    currRowA  currColB 
  // Ҹ ˻ϱ  Ѵ.  
  int currRowIndex = 0; 
  int currColIndex = 0;
	//a  currRowA ù°  ġ Ÿ. 
  int currRowBegin = 0;
  // b   a  Ÿ. 
  int currRowA = a.data[0].row;
  //a  currRowA  b ̴.     
  int currColB = bXpose.data[0].row; 
 
  int lastInResult = -1;
  
  int sum = 0;  
  //      ü  
  SparseMatrix d={a.rows, b.cols, lastInResult+1};     
  //    
  // a   0 +1 ġ  
  a.data[a.terms].row = a.rows;    
  bXpose.data[b.terms].row = b.cols;  
  bXpose.data[b.terms].col = -1; 
  
  // a 0 ƴ   
  while(currRowIndex < a.terms)
  { //d  currRowA 
    //a  currRowA  b ̴.     
    currColB = bXpose.data[0].row; 
    currColIndex = 0;
    
    // b 0 ƴ   
    while (currColIndex <= b.terms)
    {
      // a  currRowA b  currColB 
      if (a.data[currRowIndex].row != currRowA){ // currRowA  
        storeSum(&sum, currRowA, currColB, &d, &lastInResult);
        
        currRowIndex=currRowBegin;
        
        //   Ѿ
        while(bXpose.data[currColIndex].row == currColB) 
          currColIndex++;
          
        currColB = bXpose.data[currColIndex].row;
      }
      
      else if(bXpose.data[currColIndex].row != currColB) {// b  currColB 
        storeSum(&sum, currRowA, currColB, &d, &lastInResult );
        // currRowA    ϵ 
        currRowIndex = currRowBegin;
        currColB = bXpose.data[currColIndex].row;
      }
      else
        if(a.data[currRowIndex].col <
		            bXpose.data[currColIndex].col)
          currRowIndex++; 
        else if(a.data[currRowIndex].col ==
		            bXpose.data[currColIndex].col){ // sum 
            sum += a.data[currRowIndex].value *
                   bXpose.data[currColIndex].value;
            currRowIndex++; 
            currColIndex++; 
        }
        else //  currColB   
         currColIndex++; 
    } // while (currColIndex <= b.terms) 
    
    while (a.data[currRowIndex].row == currRowA) //   
      currRowIndex++;
    
    currRowBegin = currRowIndex; 
    currRowA = a.data[currRowIndex].row;    
  } // while (currRowIndex<a.terms) 
  return d;
}

int main()
{
  SparseMatrix A={    3, 3, 3,
                   {{ 0, 0, 1}, 
                    { 1, 0, 1},
                    { 2, 0, 1}
                   }
                 };

  SparseMatrix B={    3, 3, 3,  
                   {{ 0, 0, 1 }, 
                    { 0, 1, 1},
                    { 0, 2, 1}
                   }
                 };
  //     ü 
  SparseMatrix D;
  //   
  D=multiply(A, B);
  //  
  printSM(A);   printSM(B);    
  printSM(D);
  
  getchar(); 
}
