#include <stdio.h>
#include <malloc.h>

typedef char element; 
typedef struct DQNode{
	element data;
	struct DQNode *llink;
	struct DQNode *rlink;
} DQNode;

typedef struct{	
	DQNode *front, *rear;
} DQueType;

DQueType *createDQue()
{
	DQueType *DQ;
	DQ = (DQueType *)malloc(sizeof(DQueType));
	DQ->front=NULL;
	DQ->rear=NULL;
	return DQ;
}

int isEmpty(DQueType *DQ) 
{ 
	if (DQ->front == NULL) {
		printf("\n Linked Queue is empty! \n");
		return 1;	 
	}
	 else return 0; 
} 

void addFront(DQueType *DQ, element item) 
{ 
	 DQNode *newNode=(DQNode *)malloc(sizeof(DQNode));
	 newNode->data = item;	 
	 if(DQ->front == NULL) {
		 DQ->front = newNode;
		 DQ->rear = newNode;		
		 newNode->rlink = NULL;
		 newNode->llink = NULL;
	 }
	 else {
		DQ->front->llink = newNode;
		newNode->rlink = DQ->front;
		newNode->llink = NULL;
		DQ->front = newNode;
	 }
}

void addRear(DQueType *DQ, element item) 
{ 
	 DQNode *newNode=(DQNode *)malloc(sizeof(DQNode));
	 newNode->data = item;	 
	 if(DQ->front == NULL) {
		 DQ->front = newNode;
		 DQ->rear = newNode;		
		 newNode->rlink = NULL;
		 newNode->llink = NULL;
	 }
	 else {
		DQ->rear->rlink = newNode;
		newNode->rlink = NULL;
		newNode->llink = DQ->rear;
		DQ->rear = newNode;
	 }
}

element deleteFront(DQueType *DQ) 
{ 
	DQNode *old = DQ->front;
	element item;
	 if (isEmpty(DQ)) return 0; 
	 else {
		 item = old->data;		 
		 if(DQ->front->rlink == NULL) {
			 DQ->front = NULL;
			 DQ->rear = NULL;
		 }
		 else {
			 DQ->front = DQ->front->rlink;
			 DQ->front->llink = NULL;
		 }			 
		 free(old);
		 return item;
	 }
} 

element deleteRear(DQueType *DQ) 
{ 
	DQNode *old = DQ->rear;
	element item;
	 if (isEmpty(DQ)) return 0; 
	 else {
		 item = old->data;		 
		 if(DQ->rear->llink == NULL) {
			 DQ->front = NULL;
			 DQ->rear = NULL;
		 }
		 else {
			 DQ->rear = DQ->rear->llink;
			 DQ->rear->rlink = NULL;
		 }			 
		 free(old);
		 return item;
	 }
} 

element peekFront(DQueType *DQ) 
{ 
	 element item;
	 if (isEmpty(DQ)) return 0; 
	 else {
		 item = DQ->front->data;
		 return item;
	 }
}

element peekRear(DQueType *DQ) 
{ 
	 element item;
	 if (isEmpty(DQ)) return 0; 
	 else {
		 item = DQ->rear->data;
		 return item;
	 }
}

void display(DQueType *DQ)
{
	DQNode *temp = DQ->front;
	printf("\n (");
	while(temp) {
		printf("%3c", temp->data);
		temp = temp->rlink;
	}
	printf(" )");
}

int main(void) 
{ 
	DQueType *DQ1 = createDQue(); 
	element data; 
	addFront(DQ1, 'A'); 	
	addFront(DQ1, 'B');  
  addRear(DQ1, 'C');	
  display(DQ1);
	
  deleteFront(DQ1);		
	deleteRear(DQ1);		
  display(DQ1);

	getchar();
} 
