#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

typedef struct TreeNode{
  char data;
  struct TreeNode* left;
  struct TreeNode*right;
} TreeNode;

TreeNode* makeRootNode(char data, TreeNode* leftNode, TreeNode* rightNode)
{
  TreeNode* root = (TreeNode *)malloc(sizeof(TreeNode));
  root->data = data;
  root->left = leftNode;
  root->right = rightNode;
  return root;
}

void preorder( TreeNode *ptr ){
  if(ptr){
    printf("%c ", ptr->data ); //  湮
    preorder( ptr->left );     //   Ʈ ˻
    preorder( ptr->right );    //   Ʈ ˻
  }
}

void inorder( TreeNode *ptr ){
  if(ptr){
    inorder( ptr->left );      //   Ʈ ˻
    printf("%c ", ptr->data ); //  湮
    inorder( ptr->right );     //   Ʈ ˻
  }
}

void postorder( TreeNode *ptr ){
  if ( ptr ){
    postorder( ptr->left );    //   Ʈ ˻
    postorder( ptr->right );   //   Ʈ ˻
    printf("%c ", ptr->data ); //  湮
  }
}
// Ʈ   ϴ Լ Ѵ. 
int getNodeCount(TreeNode *node)
{
  int count=0;
  if( node != NULL )
    count = 1 + getNodeCount(node->left)+getNodeCount(node->right);
  return count;
}
int max(int a, int b)
{
  if(a>b)
    return a;
  else
    return b;
}
// Ʈ ̸ ϴ Լ Ѵ. 
int getHeight(TreeNode *node)
{
  int height=0;
  if( node != NULL )
    height = 1 + max(getHeight(node->left), getHeight(node->right));
  return height;
}
//         A(n1)
//       /     \
//     B(n2)    C(n3)
//    /   \     /    \
// D(n4) E(n5) F(n6)  G(n7)
int main()
{
  TreeNode *n1, *n2, *n3, *n4, *n5, *n6, *n7;

  n7 = makeRootNode('G', NULL, NULL);
  n6 = makeRootNode('F', NULL, NULL);
  n5 = makeRootNode('E', NULL, NULL);
  n4 = makeRootNode('D', NULL, NULL);
  n3 = makeRootNode('C', n6, n7);
  n2 = makeRootNode('B', n4, n5);
  n1 = makeRootNode('A', n2, n3);
  
  // Ʈ 带 n1 Ѵ.
  TreeNode* root = n1;
  printf("\n  Ʈ   : %d ", getNodeCount(root));
  printf("\n  Ʈ  : %d ", getHeight(root));
  
  getchar();
}

