
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

typedef struct TreeNode{
  char data;
  struct TreeNode* left;
  struct TreeNode*right;
} TreeNode;

TreeNode* makeRootNode(char data, TreeNode* leftNode, TreeNode* rightNode)
{
  TreeNode* root = (TreeNode *)malloc(sizeof(TreeNode));
  root->data = data;
  root->left = leftNode;
  root->right = rightNode;
  return root;
}

void preorder( TreeNode *ptr ){
  if(ptr){
    printf("%c ", ptr->data ); //  湮
    preorder( ptr->left );     //   Ʈ ˻
    preorder( ptr->right );    //   Ʈ ˻
  }
}

void inorder( TreeNode *ptr ){
  if(ptr){
    inorder( ptr->left );      //   Ʈ ˻
    printf("%c ", ptr->data ); //  湮
    inorder( ptr->right );     //   Ʈ ˻
  }
}

void postorder( TreeNode *ptr ){
  if ( ptr ){
    postorder( ptr->left );    //   Ʈ ˻
    postorder( ptr->right );   //   Ʈ ˻
    printf("%c ", ptr->data ); //  湮
  }
}
//              +(n1)
//            /      \
//         +(n2)      E(n3)    
//       /      \
//     *(n4)    /(n5)
//    /   \     /    \
// A(n6) B(n7) C(n8)  D(n9)
int main()
{
  TreeNode *n1, *n2, *n3, *n4, *n5, *n6, *n7, *n8, *n9;
  
  n9 = makeRootNode('D', NULL, NULL);
  n8 = makeRootNode('C', NULL, NULL);
  n7 = makeRootNode('B', NULL, NULL);
  n6 = makeRootNode('A', NULL, NULL);
  n5 = makeRootNode('/', n8, n9);
  n4 = makeRootNode('*', n6, n7);
  n3 = makeRootNode('E', NULL, NULL);
  n2 = makeRootNode('+', n4, n5);
  n1 = makeRootNode('+', n2, n3);
  
  // Ʈ 带 n1 Ѵ.
  TreeNode* root = n1;
  printf("\n inorder : \t");
  inorder(root);
  printf("\n preorder : \t");
  preorder(root);
  printf("\n postorder : \t");
  postorder(root);

  getchar();
}

