#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

typedef struct TreeNode{
  int data;
  struct TreeNode* left;
  struct TreeNode*right;
} TreeNode;

TreeNode* makeRootNode(int data, TreeNode* leftNode, TreeNode* rightNode)
{
  TreeNode* root = (TreeNode *)malloc(sizeof(TreeNode));
  root->data = data;
  root->left = leftNode;
  root->right = rightNode;
  return root;
}

int calcDirSize(TreeNode *ptr){
  int leftSize, rightSize;
  if ( ptr ){
    leftSize = calcDirSize( ptr->left );    
    rightSize = calcDirSize( ptr->right );   
    return(ptr->data + leftSize + rightSize); 
  }
  return 0;
}
//              0kb(n1)
//            /       |
//         50kb(n2)  100kb(n3)    
//                  /    |
//           200kb(n4)  500kb(n5)
int main()
{
  TreeNode *n1, *n2, *n3, *n4, *n5;
  
  n5 = makeRootNode(500, NULL, NULL);
  n4 = makeRootNode(200, NULL, NULL);
  n3 = makeRootNode(100, n4, n5);
  n2 = makeRootNode(50, NULL, NULL);
  n1 = makeRootNode(0, n2, n3);
  
  // Ʈ 带 n1 Ѵ.
  TreeNode* root = n1;
  printf("\n  뷮 : %d \n", calcDirSize(root));

  getchar();
}

