#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

typedef struct TreeNode{
  char data;
  struct TreeNode* left;
  struct TreeNode* right;
  int is_thread;
} TreeNode;

TreeNode* makeRootNode(char data, TreeNode* leftNode, 
   TreeNode* rightNode, int is_thread)
{
  TreeNode* root = (TreeNode *)malloc(sizeof(TreeNode));
  root->data = data;
  root->left = leftNode;
  root->right = rightNode;
  root->is_thread=is_thread;
  return root;
}

TreeNode *findThreadSuccessor(TreeNode *p)
{
  TreeNode *q = p->right;
  if( q==NULL || p->is_thread == true)
    return q;
  while( q->left != NULL ) q = q->left;
  return q;
}

void threadInorder(TreeNode *t)
{
  TreeNode *q;
  q=t;
  while (q->left) q = q->left;
  do
  {
    printf("%c ", q->data);
    q = findThreadSuccessor(q);
  } while(q);
}

//         *(n1)
//       /     |
//     +(n2)    -(n3)
//    /   |     /    |
// A(n4) B(n5) C(n6)  D(n7)
int main()
{
  TreeNode *n1, *n2, *n3, *n4, *n5, *n6, *n7;

  n7 = makeRootNode('D', NULL, NULL, 0);
  n6 = makeRootNode('C', NULL, NULL, 1);
  n5 = makeRootNode('B', NULL, NULL, 1);
  n4 = makeRootNode('A', NULL, NULL, 1);
  
  n3 = makeRootNode('-', n6, n7, 0);
  n2 = makeRootNode('+', n4, n5, 0);
  n1 = makeRootNode('*', n2, n3, 0);
  
  n4->right= n2;
  n5->right= n1;
  n6->right= n3;
    
  // Ʈ 带 n1 Ѵ.
  TreeNode* root = n1;
  printf("\n inorder : ");
  threadInorder(root);

  getchar();
}
