#include <stdio.h>
#include <stdlib.h>
#define MAX_ELEMENT 100

typedef struct {
  int heap[MAX_ELEMENT];
  int heap_size;
} HeapType;

HeapType* createHeap()
{
  HeapType* h = (HeapType*)malloc(sizeof(HeapType));
  h->heap_size=0;
  return h;
}

void insertHeap(HeapType *h, int item)
{
  int i;
  h->heap_size = h->heap_size +1;
  i = h->heap_size;
  while((i!=1) && (item > h->heap[i/2])){
    h->heap[i] = h->heap[i/2];
    i/=2;
  }
  h->heap[i] = item;
}

int deleteHeap(HeapType *h)
{
  int parent, child;
  int item, temp;
  item = h->heap[1];
  temp = h->heap[h->heap_size];
    h->heap_size = h->heap_size -1;
  parent = 1;
  child = 2;
  while(child <= h->heap_size) {
    if((child < h->heap_size) && (h->heap[child]) < h->heap[child+1]) 
      child++;
    if (temp >= h->heap[child]) break;

    h->heap[parent] = h->heap[child];
    parent = child;
    child = child*2;  
  }
  h->heap[parent] = temp;
  return item;
}

void printHeap(HeapType *h)
{
  int i;
  printf("\n Heap : ");
  for(i=1; i<=  h->heap_size; i++){
    printf("[%d] ", h->heap[i]);  
  }
}

int main()
{
  int i, n, item;
  HeapType *heap = createHeap();
  insertHeap(heap, 20);
  insertHeap(heap, 15);
  insertHeap(heap, 19);
  insertHeap(heap, 8);
  insertHeap(heap, 13);
  insertHeap(heap, 10);
  
  printHeap(heap);

  printf("\n\n insert : %d ", item);
  insertHeap(heap, 23);
  
  printHeap(heap);
  
  n= heap->heap_size;
  for(i=1; i<=n; i++){
    item = deleteHeap(heap);
    printf("\n\n delete : %d ", item);
    printHeap(heap);
  }

  getchar();
}
