#include <stdio.h>
#include <stdlib.h>
#define RADIX 10
#define DIGIT  2

typedef int element; 

typedef struct QNode{
	element data;
	struct QNode *link;
} QNode;

typedef struct{	
	QNode *front, *rear;
} LQueueType;

LQueueType *createLinkedQueue()
{
	LQueueType *LQ;
	LQ = (LQueueType *)malloc(sizeof(LQueueType));
	LQ->front=NULL;
	LQ->rear=NULL;
	return LQ;
}

int isEmpty(LQueueType *LQ) 
{ 
	if (LQ->front == NULL) 	return 1;	 
	else return 0; 
} 

void enQueue(LQueueType *LQ, element item) 
{ 
	 QNode *newNode=(QNode *)malloc(sizeof(QNode));
	 newNode->data = item;
	 newNode->link = NULL;
	 if(LQ->front == NULL) {
		 LQ->front = newNode;
		 LQ->rear = newNode;		
	 }
	 else {
		LQ->rear->link = newNode;
		LQ->rear = newNode;
	 }
}

element deQueue(LQueueType *LQ) 
{ 
	QNode *old = LQ->front;
	element item;
	 if (isEmpty(LQ)) return 0; 
	 else {
		 item = old->data;
		 LQ->front = LQ->front->link; 
		 if(LQ->front == NULL) 
			LQ->rear = NULL;
		 free(old);
		 return item;
	 }
} 

void radixSort(int list[], int n)
{
	int i, bucket, d, factor=1;
	LQueueType *Q[RADIX];
	for(bucket=0; bucket<RADIX; bucket++) 
     Q[bucket]=createLinkedQueue();
	for(d=0; d<DIGIT; d++){
		for(i=0; i<n; i++)
			enQueue(Q[(list[i]/factor)%10], list[i]);
		for(bucket=0, i=0; bucket<RADIX; bucket++)
			while(!isEmpty(Q[bucket]))
				list[i++]=deQueue(Q[bucket]);
		factor=factor*10;
		printf("\n step %d : ", d+1);
		for(i=0; i<n; i++) 
       printf(" %d", list[i]);
	}
}

int main()
{
	int list[8]={32, 20, 11, 26, 78, 43, 56, 18};
	int i;
	int size = 8;
	printf("----------- before radix sort ----------------\n");
	for(i=0; i<size; i++) 
    printf(" %d", list[i]);

	printf("\n\n----------- radix sorting --------------------"); 
	radixSort(list, size);

  printf("\n\n----------- after radix sort -----------------\n");
	for(i=0; i<size; i++) 
    printf(" %d", list[i]);
 
	getchar();
}
