#include <stdio.h>

#define MAX_ELEMENT 200
typedef struct {
  int key;
} element;

typedef struct {
  element heap[MAX_ELEMENT];
  int heap_size;
} HeapType;

void init(HeapType *h)
{
  h->heap_size =0;
}

void insertHeap(HeapType *h, element item) 
{ 
    int i; 
    i = ++(h->heap_size); 

    while((i != 1) && (item.key < h->heap[i/2].key)){ 
     h->heap[i] = h->heap[i/2]; 
       i /= 2; 
    } 
    h->heap[i] = item;     
} 

element deleteHeap(HeapType *h) 
{ 
  int parent, child; 
  element item, temp;

  item = h->heap[1];
  temp = h->heap[(h->heap_size)--];
  parent = 1;  
  child = 2;
  while( child <= h->heap_size ){
    if( ( child < h->heap_size ) && 
        (h->heap[child].key) > h->heap[child+1].key)
      child++;
    if( temp.key <= h->heap[child].key ) 
      break;
    h->heap[parent] = h->heap[child];
    parent = child;
    child *= 2;
  }
  h->heap[parent] = temp;
  return item;
} 

void heapSort(element a[], int n)
{
  int i;
  HeapType h;

  init(&h);
  for(i=0;i<n;i++){
    insertHeap(&h, a[i]);
  }
  for(i=0;i<n;i++){
    a[i] = deleteHeap(&h);
  }
}

int main()
{  
  element test[] = {{20}, {15}, {19}, {8}, {13}, {10}};

  printf("----------- before heap sort ----------------\n");
  for(int i=0; i<6; i++)
    printf("  %d ", test[i]);
    
  heapSort(test,6);
  
  printf("\n\n----------- after heap sort -----------------\n");
  for(int i=0; i<6; i++)
    printf("  %d ", test[i]);
    
  getchar();
}
