#include <stdio.h>
#include <memory.h>
#include <stdlib.h>
#define MAX_VERTEX 10
#define FALSE 0
#define TRUE  1

typedef struct GraphNode{
  int vertex;
  struct GraphNode* link;
} GraphNode;

typedef struct GraphType{
  int n;
  GraphNode* adjList_H[MAX_VERTEX];
  int visited[MAX_VERTEX];
} GraphType;

typedef struct QNode{
  int data;
  struct QNode *link;
} QNode;

typedef struct{  
  QNode *front, *rear;
} LQueueType;

LQueueType *createLinkedQueue()
{
  LQueueType *LQ;
  LQ = (LQueueType *)malloc(sizeof(LQueueType));
  LQ->front=NULL;
  LQ->rear=NULL;
  return LQ;
}

int isEmpty(LQueueType *LQ) 
{ 
  if (LQ->front == NULL) {  
    return 1;   
  }
   else return 0; 
} 

void enQueue(LQueueType *LQ, int item) 
{ 
   QNode *newNode=(QNode *)malloc(sizeof(QNode));
   newNode->data = item;
   newNode->link = NULL;
   if(LQ->front == NULL) {
     LQ->front = newNode;
     LQ->rear = newNode;    
   }
   else {
    LQ->rear->link = newNode;
    LQ->rear = newNode;
   }
}

int deQueue(LQueueType *LQ) 
{ 
  QNode *old = LQ->front;
  int item;
   if (isEmpty(LQ)) return 0; 
   else {
     item = old->data;
     LQ->front = LQ->front->link; 
     if(LQ->front == NULL) 
      LQ->rear = NULL;
     free(old);
     return item;
   }
} 

void createGraph(GraphType* g)
{
  int v;
  g->n = 0;
  for(v=0; v<MAX_VERTEX; v++){
    g->visited[v] = FALSE;
    g->adjList_H[v]=NULL;
  }
}

void insertVertex(GraphType* g, int v)
{
  if(((g->n)+1)>MAX_VERTEX){
    printf("\n ׷   ʰϿϴ!");
    return;
  }
  g->n++;
}

void insertEdge(GraphType* g, int u, int v)
{
  GraphNode* node;
  if(u>=g->n || v>=g->n) {
    printf("\n ׷  Դϴ!");
    return;
  }
  node = (GraphNode *)malloc(sizeof(GraphNode));
  node->vertex = v;
  node->link = g->adjList_H[u];
  g->adjList_H[u] = node;
}

void printAdjList(GraphType* g)
{
  int i;
  GraphNode* p;
  for(i=0; i<g->n; i++){
    printf("\n\t\t %c Ʈ", i +65);
    p= g->adjList_H[i];
    while(p){
      printf(" -> %c", p->vertex +65);
      p = p->link;    
    }
  }
}

void bfsAdjList(GraphType* g, int v)
{
  GraphNode* w;  
  LQueueType* Q;    // ť
  Q = createLinkedQueue();
  g->visited[v] = TRUE;
  printf(" %c", v +65);
  enQueue(Q, v);
  while(! isEmpty(Q)){    
    v=deQueue(Q);
    for(w=g->adjList_H[v]; w; w=w->link)   //  ִ  
      if (!g->visited[w->vertex]){      // 湮  ؼ 
        g->visited[w->vertex] = TRUE;
        printf(" %c", w->vertex +65);  //  0~6 A~G ٲپ 
        enQueue(Q, w->vertex);        
      }                
  } 
}

int main()
{
  int i;
  GraphType *G; 
  G = (GraphType *)malloc(sizeof(GraphType));
  
  createGraph(G); 
  for(i=0; i<6; i++)
    insertVertex(G, i);

  insertEdge(G, 0, 4);    
  insertEdge(G, 0, 1); 
 
  insertEdge(G, 1, 2);
  insertEdge(G, 1, 0); 
 
  insertEdge(G, 2, 4);
  insertEdge(G, 2, 3);
  insertEdge(G, 2, 1);
  
  insertEdge(G, 3, 2);
  insertEdge(G, 3, 1);
  
  insertEdge(G, 4, 5);
  insertEdge(G, 4, 2);  
  insertEdge(G, 4, 0);
  
  insertEdge(G, 5, 4);
  printf("\n G  Ʈ ");
  printAdjList(G);

  printf("\n\n ʺ켱Ž >> ");  
  bfsAdjList(G, 0);    

  getchar();
}
