#include <stdio.h>
#include <stdlib.h>
#include <memory.h>

struct AvlNode   {
    struct AvlNode *left_child;
    struct AvlNode *right_child;  
    int data;              
};

struct AvlNode *root;

int max(int a, int b)
{
    if(a>b)
      return a;
    else
      return b;
}
//  ȸ Լ
struct AvlNode* rotateRight(struct AvlNode *parent)
{
	struct AvlNode* child = parent->left_child;
	parent->left_child = child->right_child;
	child->right_child = parent;
	return child;
}
//  ȸ Լ
struct AvlNode* rotateLeft(struct AvlNode *parent)
{
	struct AvlNode *child = parent->right_child;
	parent->right_child = child->left_child;
	child->left_child = parent;
	return child;
}
// - ȸ Լ
struct AvlNode* rotateRightLeft(struct AvlNode *parent)
{
	struct AvlNode *child = parent->right_child;
	parent->right_child = rotateRight(child);
	return rotateLeft(parent);
}
// - ȸ Լ
struct AvlNode* rotateLeftRight(struct AvlNode *parent)
{
	struct AvlNode *child = parent->left_child;
	parent->left_child = rotateLeft(child);
	return rotateRight(parent);
}
// Ʈ ̸ ȯ
int getHeight(struct AvlNode *node)
{
	int height=0;
	if( node != NULL )
		height = 1 + max(getHeight(node->left_child), 
						getHeight(node->right_child));
	return height;
}
//  μ ȯ
int getHeightDiff(struct AvlNode *node) 
{
	if( node == NULL ) return 0;
	return getHeight(node->left_child) - getHeight(node->right_child);
} 
// Ʈ Ʈ 
struct AvlNode *rebalance(struct AvlNode **node)
{
	int height_diff = getHeightDiff(*node);
	if( height_diff > 1 ){
		if( getHeightDiff((*node)->left_child) > 0 )
			*node = rotateRight(*node);
		else
			*node = rotateLeftRight(*node);
	}
	else if ( height_diff < -1 ){
		if( getHeightDiff((*node)->right_child) < 0 )
			*node = rotateLeft(*node);
		else
			*node = rotateRightLeft(*node);
	}
	return *node;
}
// AVL Ʈ  
struct AvlNode* avlAdd(struct AvlNode **root, int new_key)
{
	if( *root == NULL ){
		*root = (struct AvlNode *)
			malloc(sizeof(struct AvlNode));
		if( *root == NULL ){
			fprintf(stderr, "޸ Ҵ \n");
			exit(1);
		}
		(*root)->data = new_key;
		(*root)->left_child = (*root)->right_child = NULL;
	}
	else if( new_key < (*root)->data ){
 (*root)->left_child=avlAdd(&((*root)->left_child), 
				new_key);
		*root = rebalance(root);
	}
	else if( new_key > (*root)->data ){
      (*root)->right_child=avlAdd(
         &((*root)->right_child), new_key);
		(*root) = rebalance(root);
	}
	else{
		fprintf(stderr, "ߺ Ű \n");
		exit(1);
	}
	return *root;
}
// AVL Ʈ ŽԼ
struct AvlNode *avlSearch(struct AvlNode *node, int key) 
{ 
	if( node == NULL ) return NULL; 
	printf("%d ", node->data);
	if( key == node->data ) return node; 
	else if( key < node->data ) 
	   	return avlSearch(node->left_child, key); 
	else 
		return avlSearch(node->right_child, key); 
} 

void inorderDisplay(struct AvlNode * root)
{
  if(root){
    inorderDisplay(root->left_child);
    printf(" %5d ", root->data);
    inorderDisplay(root->right_child);
  }
}

int main()
{
	//8,9,10,2,1,5,3,6,4,7,11,12
	avlAdd(&root, 8);
	avlAdd(&root, 9);
	avlAdd(&root, 10);
	avlAdd(&root, 2);
	avlAdd(&root, 1);
	avlAdd(&root, 5);
	avlAdd(&root, 3);
	avlAdd(&root, 6);
	avlAdd(&root, 4);
	avlAdd(&root, 7);
	avlAdd(&root, 11);
	avlAdd(&root, 12);
	
	inorderDisplay(root);
	
	avlSearch(root, 12);
  
  getchar();
}
